""" Main """
import time

import BApplication
import BMessage
import BMessenger
import BNode
import BNodeInfo
import BEntry
from AppKit import *

from modules.constants import *
import modules.people
import modules.ui
from modules.log import log

from window import ChatWindow

class MainApp(BApplication.BApplication):
	def __init__(self, sig):
		BApplication.BApplication.__init__(self, sig)
		self.refs = False
		self.SetPulseRate(1000)

	def Pulse(self):
		if self.CountWindows() < 1:
			self.PostMessage(B_QUIT_REQUESTED)

	def RefsReceived(self, msg):
		if msg.what == B_REFS_RECEIVED:
			self.refs = True
			ix = 0
			while True:
				try:
					ref = msg.FindRef("refs", ix)
				except BMessage.error, val:
					break
				else:
					bnode = BNode.BNode(ref)
					bnode.InitCheck()
					attrinfo = bnode.GetAttrInfo('BEOS:TYPE')
					ftype = bnode.ReadAttr('BEOS:TYPE',0,0,attrinfo[1]-1)
					if ftype == 'application/x-person':
						try:
							attrinfo = bnode.GetAttrInfo('Jabber:JID')
							jid = bnode.ReadAttr('Jabber:JID',0,0,attrinfo[1]-1)
						except BNode.error:
							pass
						else:
							win = modules.ui.findWindowByJID(jid)
							if win is not None:
								win.Activate()
							else:
								bentry = BEntry.BEntry(ref)
								win = ChatWindow(jid, bentry)
								win.Show()
				ix += 1

	def MessageReceived(self, msg):
		if msg.what == INBOUND_MESSAGE:
			win = modules.ui.findWindowByJID(msg.FindString('from'))
			if win is None:
				jid = msg.FindString('from')
				jidentry = modules.people.getEntryForJID(jid)
				win = ChatWindow(jid, jidentry)
				win.Show()
			win.PostMessage(msg)
#		elif msg.what == OUTBOUND_MESSAGE:
#			try:
#				messenger = BMessenger.BMessenger(SIG_HERMOD)
#			except BMessenger.error:
#				errdlg = modules.ui.ErrorBox('Failed to send chat message. Hermod not running.')
#			else:
#				messenger.SendMessage(msg)
		else:
			if msg.what == STATUS_ERROR:
				msg.PrintToStream()
				msg.FindMessage('in-reply-to')

# Main
def main():
	# Start the App	
	ThisApp = MainApp(SIG_JABBERCHAT)
	try:
		ThisApp.Run()
	except:
		trace = traceback.extract_stack()[-2]
		msg = '%s() [%s:%i]' % (trace[FUNCNAME], os.path.split(trace[FILENAME])[-1], trace[LINENO])
		log(msg)
		modules.ui.ErrorBox(msg, True)
		try:
			ThisApp.PostMessage(B_QUIT_REQUESTED)
		except:
			pass

# Do the Mario
if __name__ == '__main__':
	main()
