""" Main """

__author__    = "Lars Hansson (lars@unet.net.ph)"
__version__   = "$Revision: 0.9 $"
__date__      = "$Date: 2003/02/25 $"


import BApplication
import BWindow
import BFile
import BEntry
import BNode
import BTextView
import BBox
import BStringView
import BTextControl
import BButton
import BMessage
import BMessenger

from AppKit import *
from InterfaceKit import *
from StorageKit import *
from SupportKit import *

from modules.constants import *
import modules.ui
from constants import *

import widgets

class Window(BWindow.BWindow):
	def __init__(self, jid=None, entry=None, subject=None, body=None, mode='new'):
		BWindow.BWindow.__init__(self, (50,50,500,300), '', 
			B_TITLED_WINDOW, B_ASYNCHRONOUS_CONTROLS)
		self.bentry = entry
		if entry is not None:
			bnode = BNode.BNode(entry)
			bnode.InitCheck()
			try:
				attrinfo = bnode.GetAttrInfo('Jabber:Subject')
				subject = bnode.ReadAttr('Jabber:Subject',0,0,attrinfo[1]-1)
			except BNode.error:
				subject = None
			try:
				attrinfo = bnode.GetAttrInfo('Jabber:From')
				sender = bnode.ReadAttr('Jabber:From',0,0,attrinfo[1]-1)
			except BNode.error:
				pass
		bounds = self.Bounds()
		if mode == 'view':
			ctlbox = widgets.ViewBox(bounds, jid=sender, subject=subject)
		elif mode == 'new':
			ctlbox = widgets.ViewBox(bounds, jid=jid, mode='new')
		elif mode == 'reply':
			print subject
			ctlbox = widgets.ViewBox(bounds, jid=jid, subject=subject, mode='reply')
		self.AddChild(ctlbox)
		self.SetTitle(ctlbox.getSubject())
		ctlframe = ctlbox.Frame()
		msgview = widgets.MessageView((0,ctlframe[3]+1,bounds[2],bounds[3]))
		if body is not None and mode != 'reply':
			msgview.SetText(body)
		elif entry is not None:
			bfile = BFile.BFile(entry, B_READ_ONLY)
			txt = ''
			data = bfile.Read(1024)
			while data != '':
				txt = '%s%s' % (txt, data) 
				data = bfile.Read(1024)
			msgview.SetText(txt)
		if mode == 'new' or mode == 'reply':
			msgview.MakeEditable(True)
		self.AddChild(msgview)
			

	def QuitRequested(self):
		if self.bentry is not None:
			bnode = BNode.BNode(self.bentry)
			bnode.WriteAttr('Jabber:MessageStatus',B_STRING_TYPE, 0,'read\0')
		return True

	def MessageReceived(self, msg):
		if msg.what == REPLY_TO_MESSAGE:
			view = self.FindView('controlbox')
			msg.AddString('sender', view.getJID())
			msg.AddString('subject', 'Re: %s' % view.getSubject())
			view = self.FindView('MessageText')
			msg.AddString('body', view.Text())
			BApplication.be_app.PostMessage(msg)
		elif msg.what == TRASH_MESSAGE:
			messenger = BMessenger.BMessenger('application/x-vnd.Be-TRAK')
			bmsg = BMessage.BMessage(TRACKER_TRASH)
			bmsg.AddRef('refs', self.bentry.GetRef())
			messenger.SendMessage(bmsg)
			self.PostMessage(B_QUIT_REQUESTED)
		if msg.what == SUBJECT_CHANGED:
			view = self.FindView('controlbox')
			self.SetTitle(view.getSubject())
		elif msg.what == SEND_MESSAGE:
			bmsg = BMessage.BMessage(OUTBOUND_MESSAGE)
			view = self.FindView('controlbox')
			bmsg.AddString('to', view.getJID())
			bmsg.AddString('subject', view.getSubject())
			view = self.FindView('MessageText')
			bmsg.AddString('body', view.Text())
			#BApplication.be_app.PostMessage(bmsg)
			messenger = BMessenger.BMessenger(SIG_HERMOD)
			print 'sending'
			reply = messenger.SendMessageReply(bmsg)
			if reply.what ==  STATUS_OK:
				self.PostMessage(B_QUIT_REQUESTED)
			else:
				modules.ui.ErrorBox(reply.FindString('errstr'), True)
		elif msg.what == CONTACT_SELECTED:
			view = self.FindView('sendbtn')
			if not view.IsEnabled():
				view.SetEnabled(True)
