""" Main """

__author__    = "Lars Hansson (lars@unet.net.ph)"
__version__   = "$Revision: 0.9 $"
__date__      = "$Date: 2003/02/25 $"

import sys
import time
import os.path
import traceback
import copy

import BApplication
import BAlert
import BMessage
import BMessenger
from AppKit import *

from modules.log import log
from modules.constants import *
from constants import *
from modules.config import Account
import modules.ui

from window import RosterWindow

# BeOS Application
class MainApp(BApplication.BApplication):
	def __init__(self, sig):
		BApplication.BApplication.__init__(self, sig)

	def ReadyToRun(self):
		self.window = RosterWindow(100, 100)
		self.window.Show()

	def MessageReceived(self, msg):
		if msg.what == RM_FP_MSG:
			self.window.PostMessage(msg)
		elif msg.what == B_SILENT_RELAUNCH:
			self.window.Activate(True)

	def QuitRequested(self):
		# a short sleep here prevents crashes on program exit
		time.sleep(0.5)
		return True

# Main
def main():
	# Start the App	
	ThisApp = MainApp(SIG_ROSTERMANAGER)
	try:
		ThisApp.Run()
	except:
		trace = traceback.extract_stack()[-2]
		msg = '%s() [%s:%i]' % (trace[FUNCNAME], os.path.split(trace[FILENAME])[-1], trace[LINENO])
		log(msg)
		modules.ui.ErrorBox(msg, True)
		try:
			# try to quit cleanly
			ThisApp.PostMessage(B_QUIT_REQUSTED)
		except:
			pass

# Do the Mario
if __name__ == '__main__':
	main()
