"""Various constants"""
VERSION = "0.9.1"

MSG_CONNECT			= 1
MSG_DISCONNECT		= 2

INBOUND_MESSAGE		= 100
OUTBOUND_MESSAGE	= 101

INBOUND_CHAT		= 112
OUTBOUND_CHAT		= 113

INBOUND_PRESENCE	= 120
OUTBOUND_PRESENCE	= 121

INBOUND_ROSTER 		= 136
OUTBOUND_ROSTER		= 137
ROSTER_ITEM_REQUEST	= 138

STATUS_CONNECTED	= 200
STATUS_DISCONNECTED	= 201
STATUS_QUIT_OK		= 202
STATUS_ERROR		= 250
STATUS_CONNECTION	= 203
STATUS_OK			= 210

PROCESS_CONNECTION	= 595
REPLY_TO_MESSAGE	= 301

ROSTER_REQUEST		= 401
ROSTER_RESPONSE		= 402

WINDOW_CLOSED		= 404


MSG_DUMMY			= 255

# Application signatures
_CREATOR				= 'LimestoneSoftware'
SIG_HERMOD			= 'application/x-vnd.%s.Hermod' % _CREATOR
SIG_JABBERMESSAGE	= 'application/x-vnd.%s.JabberMessage' % _CREATOR
SIG_JABBERCONTACT	= 'application/x-vnd.%s.JabberContact' % _CREATOR
SIG_JABBERCHAT		= 'application/x-vnd.%s.JabberChat' % _CREATOR
SIG_PREFERENCES		= 'application/x-vnd.%s.Hermod-Preferences' % _CREATOR
SIG_DISCO			= 'application/x-vnd.%s.Hermod-Disco' % _CREATOR
SIG_ROSTERMANAGER	= 'application/x-vnd.%s.Hermod-RosterManager' % _CREATOR

# Components of stack trace (indices to tuple)
FILENAME, LINENO, FUNCNAME = 0, 1, 2        #SOURCELINE = 3 ; not used

