""" Functions to work with People files """
import BDirectory
import BEntry
import BNode
import BQuery
import BVolumeRoster
import BEntryList

_volumeroster = BVolumeRoster.BVolumeRoster()
_bootvolume = _volumeroster.GetBootVolume()

def clearAll():
	q = BQuery.BQuery()
	q.SetPredicate('((Jabber:JID=="*")&&(BEOS:TYPE=="application/x-person"))')
	q.SetVolume(_bootvolume)
	q.Fetch()
	while True:
		try:
			entry = q.GetNextEntry()
		except BEntryList.error:
			break
		else:
			attributes = ['Jabber:Online','Jabber:Show','Jabber:Status']
			bnode = BNode.BNode(entry)
			for attr in attributes:
				try:
					bnode.RemoveAttr(attr)
				except BNode.error:
					pass


def getEntryForJID(jid):
	q = BQuery.BQuery()
	q.SetPredicate('((Jabber:JID=="%s")&&(BEOS:TYPE=="application/x-person"))' % jid)
	q.SetVolume(_bootvolume)
	q.Fetch()
	while True:
		try:
			entry = q.GetNextEntry()
		except BEntryList.error:
			return
		else:
			return entry

def getJIDs():
	q = BQuery.BQuery()
	q.SetPredicate('((Jabber:JID=="*")&&(BEOS:TYPE=="application/x-person"))')
	q.SetVolume(_bootvolume)
	q.Fetch()
	jids = []
	while True:
		try:
			entry = q.GetNextEntry()
		except BEntryList.error:
			break
		else:
			try:
				node = BNode.BNode(entry)
				node.InitCheck()
				attrinfo = node.GetAttrInfo('Jabber:JID')
				jid = node.ReadAttr('Jabber:JID',0,0,attrinfo[1]-1)
			except BNode.error:
				pass
			else:
				jids.append(jid)
	return jids
