""" UI support functions """
import BApplication
import BAlert
import BMenuItem
import BMessage
import BSeparatorItem
import BTextControl

from InterfaceKit import *
from AppKit import *

from modules.constants import *

### Alert dialogs
def ShowAbout():
	dlg = BAlert.BAlert('About Hermod',
		'Hermod %s\nA Jabber client for BeOS\nCopyright 2004 Lars Hansson' % VERSION,
		'Enough already')
	dlg.Go(None)

def ErrorBox(msg, sync=False):
	dlg = BAlert.BAlert('Error Dialog', '%s' % msg, 'Make it go away', None, None, None, B_STOP_ALERT)
	if sync:
		dlg.Go()
	else:
		dlg.Go(None)

####
class ModalPrompt(BAlert.BAlert):
	def __init__(self, name, label, type=B_EMPTY_ALERT):
		BAlert.BAlert.__init__(self,name, '', 'Cancel', 'Ok', None, None, B_IDEA_ALERT)
		self.result = None
		tv = self.TextView()
		tvframe = tv.Frame()
		parent = tv.Parent()
		parent.RemoveChild(tv)
		bounds = parent.Bounds()
		tc = BTextControl.BTextControl((tvframe[0],tvframe[1],bounds[2]-5,0),'inputctl', label ,None, None, B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW|B_NAVIGABLE)
		div = tc.StringWidth(label)
		tc.SetDivider(div + 5)
		parent.AddChild(tc)

	def MessageReceived(self, msg):
		if msg.what == 1095521346:
			which = msg.FindInt32('which')
			if which == 1:
				tc = self.FindView('inputctl')
				self.result = tc.Text()
			self.PostMessage(B_QUIT_REQUESTED)

	def Go(self):
		tc = self.FindView('inputctl')
		tc.MakeFocus(True)
		BAlert.BAlert.Go(self)
		return self.result

### Misc functions
def findWindowByInstance(instance):
	"""Find a window by it's name"""
	wins = BApplication.be_app.CountWindows()
	ix = 0
	while ix < wins:
		curwin = BApplication.be_app.WindowAt(ix)
		if isinstance(curwin, instance):
			return curwin
		ix += 1

def findWindowByJID(jid):
	"""Find a window JID"""
	wins = BApplication.be_app.CountWindows()
	ix = 0
	while ix < wins:
		curwin = BApplication.be_app.WindowAt(ix)
		try:
			if curwin.JID == jid:
				return curwin
		except AttributeError:
			pass
		ix += 1

def simpleMenu(menu, items):
	for menuitem in items:
		if menuitem[0] == 'sep':
			menu.AddItem(BSeparatorItem.BSeparatorItem())
		elif isinstance(menuitem[1], BMessage.BMessage):
			item = BMenuItem.BMenuItem(menuitem[0], menuitem[1])
			menu.AddItem(item)
		else:
			item = BMenuItem.BMenuItem(menuitem[0], BMessage.BMessage(menuitem[1]))
			menu.AddItem(item)
