"""Misc utility functions"""
import BApplication
import BMessage
import BRoster

from constants import *

def ErrorMessage(errstr):
	"""Generic error messge"""
	bmsg = BMessage.BMessage(STATUS_ERROR)
	bmsg.AddString('errstr', errstr)
	return bmsg

def launchApp(sig):
	"""Launch an app by signature or activate it if already running"""
	if BRoster.be_roster.IsRunning(sig):
		appinfo = BRoster.be_roster.GetAppInfo(sig)
		BRoster.be_roster.ActivateApp(appinfo[1])
	else:
		BRoster.be_roster.Launch(sig)

def toUTF8(str):
	"""Convert a string to UTF-8"""
	if str is None:
		return None
	else:
		return str.encode('utf-8','replace')

	
